#region << 版 本 注 释 >>

/*--------------------------------------------------------------------
* 版权所有 (c) 2025 WenJY 保留所有权利。
* CLR版本：4.0.30319.42000
* 机器名称：Mr.Wen's MacBook Pro
* 命名空间：Sln.Iot.CFX
* 唯一标识：CB14024A-08C4-4FF4-BD6C-8E8667D00263
*
* 创建者：WenJY
* 电子邮箱：
* 创建时间：2025-10-24 15:23:00
* 版本：V1.0.0
* 描述：
*
*--------------------------------------------------------------------
* 修改人：
* 时间：
* 修改说明：
*
* 版本：V1.0.0
*--------------------------------------------------------------------*/

#endregion << 版 本 注 释 >>

using CFX;
using CFX.ResourcePerformance;
using CFX.Structures;
using Sln.Iot.Serilog;

namespace Sln.Iot.CFX.RequestReceived;

/// <summary>
/// 5.4.4.1.5 - 查询当前有无错误
/// GetActiveFaultsRequest/Response
/// </summary>
public class BaseGetActiveFaultsRequestReceived
{
    /// <summary>
    /// 
    /// </summary>
    /// <param name="request"></param>
    /// <param name="response"></param>
    public void Handle(GetActiveFaultsRequest request, out CFXMessage response)
    {
        try
        {
            response = SubHandle(request);
        }
        catch (Exception e)
        {
            //无法响应时上传NotSupportedResponse
            response = new NotSupportedResponse()
            {
                RequestResult = new RequestResult()
                {
                    Result = StatusResult.Failed,
                    ResultCode = 0,
                    Message = e.Message
                }
            };
            SerilogHelper.Instance.Error("请求数据解析异常", e);
        }
    }

    /// <summary>
    /// 子类重写处理
    /// </summary>
    /// <param name="request"></param>
    /// <returns></returns>
    public virtual CFXMessage SubHandle(GetActiveFaultsRequest request)
    {
        CFXMessage response = new GetActiveFaultsResponse()
        {
            Result = new RequestResult()
            {
                Result = StatusResult.Success,
                ResultCode = 0,
                Message = "",
            },
            ActiveFaults = new List<Fault>()
                {
                    new Fault()
                    {
                        Description = "测试错误1",
                        FaultCode = "5003",
                    }
                }
        };

        return response;
    }
}